//		----------------------------------------------------------
//		-- fredrik olofsson 040226								--
//		-- ported to pd 060510									--
//		-- converted from abstraction with the same name		--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"

static t_class *this_class;

typedef struct _f0_beats_to_frames {
	t_object x_ob;
	t_float x_valLeft;
	t_float x_valMiddle;
	t_float x_valRight;
	t_float x_valOut;
	t_outlet *x_out;
} x_f0_beats_to_frames;

void f0_beats_to_frames_func(x_f0_beats_to_frames *f0_beats_to_frames);

//----------------------------------------------------------------------------------------------
void *f0_beats_to_frames_new(t_symbol *s, int argc, t_atom *argv) {
	x_f0_beats_to_frames *f0_beats_to_frames= (x_f0_beats_to_frames *)pd_new(this_class);
	floatinlet_new(&f0_beats_to_frames->x_ob, &f0_beats_to_frames->x_valMiddle);
	floatinlet_new(&f0_beats_to_frames->x_ob, &f0_beats_to_frames->x_valRight);
	f0_beats_to_frames->x_valLeft= 0;
	f0_beats_to_frames->x_valMiddle= 120;
	f0_beats_to_frames->x_valRight= 20;
	f0_beats_to_frames->x_valOut= 0;
	switch(argc) {
		case 2:
			f0_beats_to_frames->x_valRight= atom_getfloat(argv+1);
		case 1:
			f0_beats_to_frames->x_valMiddle= atom_getfloat(argv);
	}
	f0_beats_to_frames->x_out= outlet_new(&f0_beats_to_frames->x_ob, gensym("float"));
	return (void *)f0_beats_to_frames;
}

//----------------------------------------------------------------------------------------------
void f0_beats_to_frames_float(x_f0_beats_to_frames *f0_beats_to_frames, t_floatarg value) {
	f0_beats_to_frames->x_valLeft= value;
	f0_beats_to_frames_func(f0_beats_to_frames);
}
void f0_beats_to_frames_bang(x_f0_beats_to_frames *f0_beats_to_frames) {
	outlet_float(f0_beats_to_frames->x_out, f0_beats_to_frames->x_valOut);
}

//----------------------------------------------------------------------------------------------
void f0_beats_to_frames_func(x_f0_beats_to_frames *f0_beats_to_frames) {
	if(f0_beats_to_frames->x_valMiddle==0) {
		f0_beats_to_frames->x_valOut= 0;
	} else {
		f0_beats_to_frames->x_valOut= (60/f0_beats_to_frames->x_valMiddle)*f0_beats_to_frames->x_valLeft*f0_beats_to_frames->x_valRight;
	}
	f0_beats_to_frames_bang(f0_beats_to_frames);
}

//----------------------------------------------------------------------------------------------
void f0_beats_to_frames_setup(void) {
	this_class= class_new(gensym("f0_beats_to_frames"), (t_newmethod)f0_beats_to_frames_new, 0, sizeof(x_f0_beats_to_frames), 0, A_GIMME, 0);
	class_addbang(this_class, (t_method)f0_beats_to_frames_bang);
	class_addfloat(this_class, f0_beats_to_frames_float);
	post("f0_beats_to_frames v1.0.1  distributed under GNU GPL license");
}
