//		----------------------------------------------------------
//		-- fredrik olofsson 010502 (rev.011004)					--
//		-- ported to pd 060510									--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#define LONG_MIN -2147483647
#define LONG_MAX 2147483647

#include "m_pd.h"
#include <stdlib.h>
#include <math.h>
#include <time.h>

static t_class *this_class;

typedef struct _f0_construct {
	t_object x_ob;
	t_int x_valLeft;
	t_int x_mapping;
	t_int x_variant;
	t_int x_cols;
	t_int x_rows;
	t_int x_width;
	t_int x_height;
	t_float x_stepX;
	t_float x_stepY;
	t_int x_movementX;
	t_int x_movementY;
	t_int x_x;
	t_int x_y;
	t_int x_dx;
	t_int x_dy;
	t_outlet *x_out;
} x_f0_construct;

void f0_construct_start(x_f0_construct *f0_construct);
void f0_construct_drawFO(x_f0_construct *f0_construct);
void f0_construct_variant1(x_f0_construct *f0_construct);
void f0_construct_variant2(x_f0_construct *f0_construct);
void f0_construct_variant3(x_f0_construct *f0_construct);
void f0_construct_variant4(x_f0_construct *f0_construct);
void f0_construct_variant5(x_f0_construct *f0_construct);
void f0_construct_variant6(x_f0_construct *f0_construct);
void f0_construct_mapping1(x_f0_construct *f0_construct, t_int iCol, t_int jRow);
void f0_construct_mapping2(x_f0_construct *f0_construct, t_int iCol, t_int jRow);
void f0_construct_mapping3(x_f0_construct *f0_construct, t_int iCol, t_int jRow);
void f0_construct_mapping4(x_f0_construct *f0_construct, t_int iCol, t_int jRow);
void f0_construct_mapping5(x_f0_construct *f0_construct, t_int i, t_int iCol, t_int jRow);
void f0_construct_mapping6(x_f0_construct *f0_construct, t_int i, t_int iCol, t_int jRow);
void f0_construct_mapping7(x_f0_construct *f0_construct, t_int i, t_int iCol, t_int jRow);
void f0_construct_mapping8(x_f0_construct *f0_construct, t_int j, t_int iCol, t_int jRow);
void f0_construct_mapping9(x_f0_construct *f0_construct, t_int j, t_int iCol, t_int jRow);
void f0_construct_mapping10(x_f0_construct *f0_construct, t_int j, t_int iCol, t_int jRow);
void f0_construct_mapping11(x_f0_construct *f0_construct, t_int i, t_int j, t_int iCol, t_int jRow);
void f0_construct_mapping12(x_f0_construct *f0_construct, t_int i, t_int j, t_int iCol, t_int jRow);
void f0_construct_mapping13(x_f0_construct *f0_construct, t_int i, t_int j, t_int iCol, t_int jRow);
void f0_construct_mapping14(x_f0_construct *f0_construct, t_int i, t_int j, t_int iCol, t_int jRow);
void f0_construct_mapping15(x_f0_construct *f0_construct, t_int i, t_int j, t_int iCol, t_int jRow);
void f0_construct_mapping16(x_f0_construct *f0_construct, t_int i, t_int j, t_int iCol, t_int jRow);
void f0_construct_slumpaRiktningX(x_f0_construct *f0_construct);
void f0_construct_slumpaRiktningY(x_f0_construct *f0_construct);
void f0_construct_slumpaRiktningXY(x_f0_construct *f0_construct);
t_int f0_construct_mirrorX(x_f0_construct *f0_construct, t_int ox);
t_int f0_construct_mirrorY(x_f0_construct *f0_construct, t_int oy);
t_int f0_construct_myRandom(void);
void f0_construct_draw(x_f0_construct *f0_construct, t_int ox, t_int oy);

//----------------------------------------------------------------------------------------------
void *f0_construct_new(t_symbol *s, int argc, t_atom *argv) {
	x_f0_construct *f0_construct= (x_f0_construct *)pd_new(this_class);
	f0_construct->x_valLeft= 1;
	f0_construct->x_mapping= 1;
	f0_construct->x_variant= 1;
	f0_construct->x_cols= 3;
	f0_construct->x_rows= 2;
	f0_construct->x_width= 200;
	f0_construct->x_height= 200;
	f0_construct->x_stepX= 1;
	f0_construct->x_stepY= 1;
	f0_construct->x_movementX= 95;
	f0_construct->x_movementY= 93;
	f0_construct->x_x= 10;
	f0_construct->x_y= 10;
	f0_construct->x_dx= 1;
	f0_construct->x_dy= 1;
	f0_construct->x_out= outlet_new(&f0_construct->x_ob, gensym("list"));
	return (void *)f0_construct;
}

//----------------------------------------------------------------------------------------------
void f0_construct_mapping(x_f0_construct *f0_construct, t_floatarg m) {
	if(m>=1&&m<=16) {
		f0_construct->x_mapping= (t_int)m;
	}
}
void f0_construct_variant(x_f0_construct *f0_construct, t_floatarg v) {
	if(v>=1&&v<=6) {
		f0_construct->x_variant= (t_int)v;
	}
}
void f0_construct_cols(x_f0_construct *f0_construct, t_floatarg col) {
	if(col>=1) {
		f0_construct->x_cols= (t_int)col;
	}
}
void f0_construct_rows(x_f0_construct *f0_construct, t_floatarg row) {
	if(row>=1) {
		f0_construct->x_rows= (t_int)row;
	}
}
void f0_construct_width(x_f0_construct *f0_construct, t_floatarg max_X) {
	if(max_X>=1) {
		f0_construct->x_width= (t_int)max_X;
	}
}
void f0_construct_height(x_f0_construct *f0_construct, t_floatarg max_Y) {
	if(max_Y>=1) {
		f0_construct->x_height= (t_int)max_Y;
	}
}
void f0_construct_stepX(x_f0_construct *f0_construct, t_float stepX) {
	f0_construct->x_stepX= stepX;
}
void f0_construct_stepY(x_f0_construct *f0_construct, t_float stepY) {
	f0_construct->x_stepY= stepY;
}
void f0_construct_movementX(x_f0_construct *f0_construct, t_floatarg movementX) {
	if(movementX>=0&&movementX<=100) {
		f0_construct->x_movementX= (t_int)movementX;
	}
}
void f0_construct_movementY(x_f0_construct *f0_construct, t_floatarg movementY) {
	if(movementY>=0&&movementY<=100) {
		f0_construct->x_movementY= (t_int)movementY;
	}
}

//----------------------------------------------------------------------------------------------
void f0_construct_start(x_f0_construct *f0_construct) {
	srand(((unsigned int)time(0))|1);
	t_int i;
	for(i= 0; i<f0_construct->x_valLeft; i++) {
		f0_construct_drawFO(f0_construct);
		f0_construct->x_x= f0_construct->x_x+(f0_construct->x_dx*f0_construct->x_stepX);			// flytta position x
		if(f0_construct->x_x<1) {																	// om vnster kant
			f0_construct->x_dx= f0_construct_myRandom()%2;											//   vnd eller st still i x-led
		} else if(f0_construct->x_x>(f0_construct->x_width/f0_construct->x_cols)) {					// om hger kant
			f0_construct->x_dx= 0-(f0_construct_myRandom()%2);										//   vnd eller st still i x-led
		}
		f0_construct->x_y= f0_construct->x_y+(f0_construct->x_dy*f0_construct->x_stepY);			// flytta position y
		if(f0_construct->x_y<1) {																	// om vre kanten
			f0_construct->x_dy= f0_construct_myRandom()%2;											//   vnd eller st still i y-led
		} else if(f0_construct->x_y>(f0_construct->x_height/f0_construct->x_rows)) {				// om nedre kanten
			f0_construct->x_dy= 0-(f0_construct_myRandom()%2);										//   vnd eller st still i y-led
		}
		switch(f0_construct->x_variant) {
			case 1:
				f0_construct_variant1(f0_construct);
				break;
			case 2:
				f0_construct_variant2(f0_construct);
				break;
			case 3:
				f0_construct_variant3(f0_construct);
				break;
			case 4:
				f0_construct_variant4(f0_construct);
				break;
			case 5:
				f0_construct_variant5(f0_construct);
				break;
			case 6:
				f0_construct_variant6(f0_construct);
				break;
		}
	}
}
void f0_construct_bang(x_f0_construct *f0_construct) {
	f0_construct_start(f0_construct);
}
void f0_construct_float(x_f0_construct *f0_construct, t_floatarg iterations) {
	if(iterations>=1) {
		f0_construct->x_valLeft= (t_int)iterations;
		f0_construct_bang(f0_construct);
	}
}

//----------------------------------------------------------------------------------------------
void f0_construct_variant1(x_f0_construct *f0_construct) {											// 1. slumpa riktningar individuellt
	if(f0_construct_myRandom()%100>=f0_construct->x_movementX) {
		f0_construct_slumpaRiktningX(f0_construct);
	}
	if(f0_construct_myRandom()%100>=f0_construct->x_movementY) {
		f0_construct_slumpaRiktningY(f0_construct);
	}
}
void f0_construct_variant2(x_f0_construct *f0_construct) {											// 2. slumpa alltid riktningar tillsammans
	f0_construct_slumpaRiktningXY(f0_construct);
}
void f0_construct_variant3(x_f0_construct *f0_construct) {											// 3. slumpa riktningar individuellt
	if(f0_construct_myRandom()%100>=f0_construct->x_movementX) {
		if(f0_construct->x_dx==0&&f0_construct->x_x>=1) {											//		dra t vnster
			f0_construct->x_dx= -1;
		} else {
			f0_construct->x_dx= 0;
		}
	}
	if(f0_construct_myRandom()%100>=f0_construct->x_movementY) {
		if(f0_construct->x_dy==0&&f0_construct->x_y>=1) {											//		dra uppt
			f0_construct->x_dy= -1;
		} else {
			f0_construct->x_dy= 0;
		}
	}
}
void f0_construct_variant4(x_f0_construct *f0_construct) {											// 4. slumpa riktningar individuellt
	if(f0_construct_myRandom()%100>=f0_construct->x_movementX) {
		if(f0_construct->x_dx==0&&f0_construct->x_x>=1) {											//		dra t vnster
			f0_construct->x_dx= -1;
		} else {
			f0_construct->x_dx= 0;
		}
	}
	if(f0_construct_myRandom()%100>=f0_construct->x_movementY) {
		if(f0_construct->x_dy==0&&f0_construct->x_y<=f0_construct->x_height/f0_construct->x_rows) {	//		dra nedt
			f0_construct->x_dy= 1;
		} else {
			f0_construct->x_dy= 0;
		}
	}
}
void f0_construct_variant5(x_f0_construct *f0_construct) {											// 5. slumpa riktningar individuellt
	if(f0_construct_myRandom()%100>=f0_construct->x_movementX) {
		if(f0_construct->x_dx==0&&f0_construct->x_x<=f0_construct->x_width/f0_construct->x_cols) {	//		dra t hger
			f0_construct->x_dx= 1;
		} else {
			f0_construct->x_dx= 0;
		}
	}
	if(f0_construct_myRandom()%100>=f0_construct->x_movementY) {
		if(f0_construct->x_dy==0&&f0_construct->x_y>=1) {											//		dra uppt
			f0_construct->x_dy= -1;
		} else {
			f0_construct->x_dy= 0;
		}
	}
}
void f0_construct_variant6(x_f0_construct *f0_construct) {											// 6. slumpa riktningar individuellt
	if(f0_construct_myRandom()%100>=f0_construct->x_movementX) {
		if(f0_construct->x_dx==0&&f0_construct->x_x<=f0_construct->x_width/f0_construct->x_cols) {	//		dra t hger
			f0_construct->x_dx= 1;
		} else {
			f0_construct->x_dx= 0;
		}
	}
	if(f0_construct_myRandom()%100>=f0_construct->x_movementY) {
		if(f0_construct->x_dy==0&&f0_construct->x_y<=f0_construct->x_height/f0_construct->x_rows) {	//		dra nedt
			f0_construct->x_dy= 1;
		} else {
			f0_construct->x_dy= 0;
		}
	}
}

//----------------------------------------------------------------------------------------------
void f0_construct_slumpaRiktningX(x_f0_construct *f0_construct) {
	f0_construct->x_dx= (f0_construct_myRandom()%3)-1;
}
void f0_construct_slumpaRiktningY(x_f0_construct *f0_construct) {
	f0_construct->x_dy= (f0_construct_myRandom()%3)-1;
}
void f0_construct_slumpaRiktningXY(x_f0_construct *f0_construct) {
	while((f0_construct->x_dx==0)&&(f0_construct->x_dy==0)) {										// kolla att inte bda riktningar blir 0
		f0_construct->x_dx= (f0_construct_myRandom()%3)-1;
		f0_construct->x_dy= (f0_construct_myRandom()%3)-1;
	}
}

//----------------------------------------------------------------------------------------------
void f0_construct_drawFO(x_f0_construct *f0_construct) {
	t_int i, j, iCol, jRow;
	srand(time(NULL));
	for(i= 0; i<f0_construct->x_cols; i++) {
		for(j= 0; j<f0_construct->x_rows; j++) {
			iCol= (f0_construct->x_width/f0_construct->x_cols)*i;
			jRow= (f0_construct->x_height/f0_construct->x_rows)*j;
			switch(f0_construct->x_mapping) {														// kolla mapping
					case 1:
						f0_construct_mapping1(f0_construct, iCol, jRow);
						break;
					case 2:
						f0_construct_mapping2(f0_construct, iCol, jRow);
						break;
					case 3:
						f0_construct_mapping3(f0_construct, iCol, jRow);
						break;
					case 4:
						f0_construct_mapping4(f0_construct, iCol, jRow);
						break;
					case 5:
						f0_construct_mapping5(f0_construct, i, iCol, jRow);
						break;
					case 6:
						f0_construct_mapping6(f0_construct, i, iCol, jRow);
						break;
					case 7:
						f0_construct_mapping7(f0_construct, i, iCol, jRow);
						break;
					case 8:
						f0_construct_mapping8(f0_construct, j, iCol, jRow);
						break;
					case 9:
						f0_construct_mapping9(f0_construct, j, iCol, jRow);
						break;
					case 10:
						f0_construct_mapping10(f0_construct, j, iCol, jRow);
						break;
					case 11:
						f0_construct_mapping11(f0_construct, i, j, iCol, jRow);
						break;
					case 12:
						f0_construct_mapping12(f0_construct, i, j, iCol, jRow);
						break;
					case 13:
						f0_construct_mapping13(f0_construct, i, j, iCol, jRow);
						break;
					case 14:
						f0_construct_mapping14(f0_construct, i, j, iCol, jRow);
						break;
					case 15:
						f0_construct_mapping15(f0_construct, i, j, iCol, jRow);
						break;
					case 16:
						f0_construct_mapping16(f0_construct, i, j, iCol, jRow);
						break;
			}
		}
	}
}

//----------------------------------------------------------------------------------------------
void f0_construct_mapping1(x_f0_construct *f0_construct, t_int iCol, t_int jRow) {										// no flip
	f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct->x_y+jRow);
}
void f0_construct_mapping2(x_f0_construct *f0_construct, t_int iCol, t_int jRow) {										// flip all x
	f0_construct_draw(f0_construct, f0_construct_mirrorX(f0_construct, f0_construct->x_x)+iCol, f0_construct->x_y+jRow);
}
void f0_construct_mapping3(x_f0_construct *f0_construct, t_int iCol, t_int jRow) {										// flip all y
	f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct_mirrorY(f0_construct, f0_construct->x_y)+jRow);
}
void f0_construct_mapping4(x_f0_construct *f0_construct, t_int iCol, t_int jRow) {										// flip all xy
	f0_construct_draw(f0_construct, f0_construct_mirrorX(f0_construct, f0_construct->x_x)+iCol, f0_construct_mirrorY(f0_construct, f0_construct->x_y)+jRow);
}
//--
void f0_construct_mapping5(x_f0_construct *f0_construct, t_int i, t_int iCol, t_int jRow) {								// flip odd col x
	if(i%2==1) {
		f0_construct_draw(f0_construct, f0_construct_mirrorX(f0_construct, f0_construct->x_x)+iCol, f0_construct->x_y+jRow);
	} else {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct->x_y+jRow);
	}
}
void f0_construct_mapping6(x_f0_construct *f0_construct, t_int i, t_int iCol, t_int jRow) {								// flip odd col y
	if(i%2==1) {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct_mirrorY(f0_construct, f0_construct->x_y)+jRow);
	} else {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct->x_y+jRow);
	}
}
void f0_construct_mapping7(x_f0_construct *f0_construct, t_int i, t_int iCol, t_int jRow) {								// flip odd col xy
	if(i%2==1) {
		f0_construct_draw(f0_construct, f0_construct_mirrorX(f0_construct, f0_construct->x_x)+iCol, f0_construct_mirrorY(f0_construct, f0_construct->x_y)+jRow);
	} else {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct->x_y+jRow);
	}
}
//--
void f0_construct_mapping8(x_f0_construct *f0_construct, t_int j, t_int iCol, t_int jRow) {								// flip odd row x
	if(j%2==1) {
		f0_construct_draw(f0_construct, f0_construct_mirrorX(f0_construct, f0_construct->x_x)+iCol, f0_construct->x_y+jRow);
	} else {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct->x_y+jRow);
	}
}
void f0_construct_mapping9(x_f0_construct *f0_construct, t_int j, t_int iCol, t_int jRow) {								// flip odd row y
	if(j%2==1) {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct_mirrorY(f0_construct, f0_construct->x_y)+jRow);
	} else {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct->x_y+jRow);
	}
}
void f0_construct_mapping10(x_f0_construct *f0_construct, t_int j, t_int iCol, t_int jRow) {							// flip odd row xy
	if(j%2==1) {
		f0_construct_draw(f0_construct, f0_construct_mirrorX(f0_construct, f0_construct->x_x)+iCol, f0_construct_mirrorY(f0_construct, f0_construct->x_y)+jRow);
	} else {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct->x_y+jRow);
	}
}
//--
void f0_construct_mapping11(x_f0_construct *f0_construct, t_int i, t_int j, t_int iCol, t_int jRow) {					// flip odd col & even row x, flip even col & odd row x
	if(i%2==1&&j%2==0) {
		f0_construct_draw(f0_construct, f0_construct_mirrorX(f0_construct, f0_construct->x_x)+iCol, f0_construct->x_y+jRow);
	} else if(i%2==0&&j%2==1) {
		f0_construct_draw(f0_construct, f0_construct_mirrorX(f0_construct, f0_construct->x_x)+iCol, f0_construct->x_y+jRow);
	} else {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct->x_y+jRow);
	}
}
void f0_construct_mapping12(x_f0_construct *f0_construct, t_int i, t_int j, t_int iCol, t_int jRow) {					// flip odd col & even row y, flip even col & odd row y
	if(i%2==1&&j%2==0) {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct_mirrorY(f0_construct, f0_construct->x_y)+jRow);
	} else if(i%2==0&&j%2==1) {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct_mirrorY(f0_construct, f0_construct->x_y)+jRow);
	} else {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct->x_y+jRow);
	}
}
void f0_construct_mapping13(x_f0_construct *f0_construct, t_int i, t_int j, t_int iCol, t_int jRow) {					// flip odd col & even row xy, flip even col & odd row xy
	if(i%2==1&&j%2==0) {
		f0_construct_draw(f0_construct, f0_construct_mirrorX(f0_construct, f0_construct->x_x)+iCol, f0_construct_mirrorY(f0_construct, f0_construct->x_y)+jRow);
	} else if(i%2==0&&j%2==1) {
		f0_construct_draw(f0_construct, f0_construct_mirrorX(f0_construct, f0_construct->x_x)+iCol, f0_construct_mirrorY(f0_construct, f0_construct->x_y)+jRow);
	} else {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct->x_y+jRow);
	}
}
//--
void f0_construct_mapping14(x_f0_construct *f0_construct, t_int i, t_int j, t_int iCol, t_int jRow) {					// flip even col & even row x, flip odd col & odd row x
	if(i%2==0&&j%2==0) {
		f0_construct_draw(f0_construct, f0_construct_mirrorX(f0_construct, f0_construct->x_x)+iCol, f0_construct->x_y+jRow);
	} else if(i%2==1&&j%2==1) {
		f0_construct_draw(f0_construct, f0_construct_mirrorX(f0_construct, f0_construct->x_x)+iCol, f0_construct->x_y+jRow);
	} else {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct->x_y+jRow);
	}
}
void f0_construct_mapping15(x_f0_construct *f0_construct, t_int i, t_int j, t_int iCol, t_int jRow) {					// flip even col & even row y, flip odd col & odd row y
	if(i%2==0&&j%2==0) {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct_mirrorY(f0_construct, f0_construct->x_y)+jRow);
	} else if(i%2==1&&j%2==1) {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct_mirrorY(f0_construct, f0_construct->x_y)+jRow);
	} else {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct->x_y+jRow);
	}
}
void f0_construct_mapping16(x_f0_construct *f0_construct, t_int i, t_int j, t_int iCol, t_int jRow) {					// flip even col & even row xy, flip odd col & odd row xy
	if(i%2==0&&j%2==0) {
		f0_construct_draw(f0_construct, f0_construct_mirrorX(f0_construct, f0_construct->x_x)+iCol, f0_construct_mirrorY(f0_construct, f0_construct->x_y)+jRow);
	} else if(i%2==1&&j%2==1) {
		f0_construct_draw(f0_construct, f0_construct_mirrorX(f0_construct, f0_construct->x_x)+iCol, f0_construct_mirrorY(f0_construct, f0_construct->x_y)+jRow);
	} else {
		f0_construct_draw(f0_construct, f0_construct->x_x+iCol, f0_construct->x_y+jRow);
	}
}

//----------------------------------------------------------------------------------------------
t_int f0_construct_mirrorX(x_f0_construct *f0_construct, t_int ox) {
	return round((f0_construct->x_width/f0_construct->x_cols)-ox);
}
t_int f0_construct_mirrorY(x_f0_construct *f0_construct, t_int oy) {
	return round((f0_construct->x_height/f0_construct->x_rows)-oy);
}
t_int f0_construct_myRandom(void) {
	return (t_int)rand();
}
void f0_construct_draw(x_f0_construct *f0_construct, t_int ox, t_int oy) {
	t_atom lista[4];
	SETFLOAT(lista, ox);
	SETFLOAT(lista+1, oy);
	SETFLOAT(lista+2, ox+1);
	SETFLOAT(lista+3, oy+1);
	outlet_list(f0_construct->x_out, gensym("list"), 4, lista);
}

//----------------------------------------------------------------------------------------------
void f0_construct_setup(void) {
	this_class= class_new(gensym("f0_construct"), (t_newmethod)f0_construct_new, 0, sizeof(x_f0_construct), 0, 0);
	class_addbang(this_class, (t_method)f0_construct_bang);
	class_addfloat(this_class, f0_construct_float);
	class_addmethod(this_class, (t_method)f0_construct_mapping, gensym("mapping"), A_DEFFLOAT, 0);
	class_addmethod(this_class, (t_method)f0_construct_variant, gensym("variant"), A_DEFFLOAT, 0);
	class_addmethod(this_class, (t_method)f0_construct_cols, gensym("cols"), A_DEFFLOAT, 0);
	class_addmethod(this_class, (t_method)f0_construct_rows, gensym("rows"), A_DEFFLOAT, 0);
	class_addmethod(this_class, (t_method)f0_construct_width, gensym("width"), A_DEFFLOAT, 0);
	class_addmethod(this_class, (t_method)f0_construct_height, gensym("height"), A_DEFFLOAT, 0);
	class_addmethod(this_class, (t_method)f0_construct_stepX, gensym("stepX"), A_DEFFLOAT, 0);
	class_addmethod(this_class, (t_method)f0_construct_stepY, gensym("stepY"), A_DEFFLOAT, 0);
	class_addmethod(this_class, (t_method)f0_construct_movementX, gensym("movementX"), A_DEFFLOAT, 0);
	class_addmethod(this_class, (t_method)f0_construct_movementY, gensym("movementY"), A_DEFFLOAT, 0);
	post("f0_construct v1.0.4  distributed under GNU GPL license");
}
