//		----------------------------------------------------------
//		-- fredrik olofsson 010522 (rev.011004)					--
//		-- ported to pd 060511									--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"
#include <math.h>

static t_class *this_class;

typedef struct _f0_distance {
	t_object x_ob;
	t_int x_size;
	t_float x_x1;
	t_float x_y1;
	t_float x_z1;
	t_float x_x2;
	t_float x_y2;
	t_float x_z2;
	t_float x_valOut;
	t_outlet *x_out;
} x_f0_distance;

void f0_distance_func(x_f0_distance *f0_distance);

//----------------------------------------------------------------------------------------------
void *f0_distance_new(t_floatarg value) {
	x_f0_distance *f0_distance= (x_f0_distance *)pd_new(this_class);
	f0_distance->x_x1= 0;
	f0_distance->x_y1= 0;
	f0_distance->x_z1= 0;
	f0_distance->x_x2= 0;
	f0_distance->x_y2= 0;
	f0_distance->x_z2= 0;
	f0_distance->x_valOut= 0;
	f0_distance->x_out= outlet_new(&f0_distance->x_ob, gensym("float"));
	if((t_int)value==2) {
		floatinlet_new(&f0_distance->x_ob, &f0_distance->x_y1);
	} else if((t_int)value==3) {
		floatinlet_new(&f0_distance->x_ob, &f0_distance->x_y1);
		floatinlet_new(&f0_distance->x_ob, &f0_distance->x_z1);
	}
	return (void *)f0_distance;
}

//----------------------------------------------------------------------------------------------
void f0_distance_func(x_f0_distance *f0_distance) {
	float x, y, z;
	x= f0_distance->x_x1-f0_distance->x_x2;
	y= f0_distance->x_y1-f0_distance->x_y2;
	z= f0_distance->x_z1-f0_distance->x_z2;
	f0_distance->x_valOut= fabs(sqrt(pow(x, 2)+pow(y, 2)+pow(z, 2)));
	f0_distance->x_x2= f0_distance->x_x1;
	f0_distance->x_y2= f0_distance->x_y1;
	f0_distance->x_z2= f0_distance->x_z1;
	outlet_float(f0_distance->x_out, f0_distance->x_valOut);
}

//----------------------------------------------------------------------------------------------
void f0_distance_float(x_f0_distance *f0_distance, t_floatarg value) {
	f0_distance->x_x1= value;
	f0_distance_func(f0_distance);
}
void f0_distance_bang(x_f0_distance *f0_distance) {
	f0_distance_func(f0_distance);
}
void f0_distance_list(x_f0_distance *f0_distance, t_symbol *s, int argc, t_atom *argv) {
	if(argc>3) {
		post("f0_distance warning: max 3 dimensions");
	}
	switch(argc) {
		case 3:
			f0_distance->x_z1= atom_getfloat(argv+2);
		case 2:
			f0_distance->x_y1= atom_getfloat(argv+1);
		case 1:
			f0_distance->x_x1= atom_getfloat(argv);
			f0_distance_func(f0_distance);
	}
}

//----------------------------------------------------------------------------------------------
void f0_distance_setup(void) {
	this_class= class_new(gensym("f0_distance"), (t_newmethod)f0_distance_new, 0, sizeof(x_f0_distance), 0, A_DEFFLOAT, 0);
	class_addbang(this_class, (t_method)f0_distance_bang);
	class_addfloat(this_class, f0_distance_float);
	class_addlist(this_class, f0_distance_list);
	post("f0_distance v1.0.4  distributed under GNU GPL license");
}
