//		----------------------------------------------------------
//		-- fredrik olofsson 010608 (rev.011004)					--
//		-- ported to pd 060512									--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"
#include <math.h>

static t_class *this_class;

typedef struct _f0_fmod {
	t_object x_ob;
	t_float x_valRight;
	t_float x_valOut;
	t_outlet *x_out;
} x_f0_fmod;

void f0_fmod_func(x_f0_fmod *f0_fmod, t_float value);

//----------------------------------------------------------------------------------------------
void *f0_fmod_new(t_floatarg value) {
	x_f0_fmod *f0_fmod= (x_f0_fmod *)pd_new(this_class);
	floatinlet_new(&f0_fmod->x_ob, &f0_fmod->x_valRight);
	if(value>0) {
		f0_fmod->x_valRight= value;
	} else {
		f0_fmod->x_valRight= 1;
	}
	f0_fmod->x_out= outlet_new(&f0_fmod->x_ob, gensym("float"));
	return (void *)f0_fmod;
}

//----------------------------------------------------------------------------------------------
void f0_fmod_float(x_f0_fmod *f0_fmod, t_floatarg value) {
	f0_fmod_func(f0_fmod, value);
}
void f0_fmod_bang(x_f0_fmod *f0_fmod) {
	outlet_float(f0_fmod->x_out, f0_fmod->x_valOut);
}

//----------------------------------------------------------------------------------------------
void f0_fmod_func(x_f0_fmod *f0_fmod, t_float value) {
	f0_fmod->x_valOut= fmod(value, f0_fmod->x_valRight);
	f0_fmod_bang(f0_fmod);
}

//----------------------------------------------------------------------------------------------
void f0_fmod_setup(void) {
	this_class= class_new(gensym("f0_fmod"), (t_newmethod)f0_fmod_new, 0, sizeof(x_f0_fmod), 0, A_DEFFLOAT, 0);
	class_addbang(this_class, (t_method)f0_fmod_bang);
	class_addfloat(this_class, f0_fmod_float);
	post("f0_fmod v1.0.2  distributed under GNU GPL license");
}
