//		----------------------------------------------------------
//		-- fredrik olofsson 010502 (rev.011004)					--
//		-- ported to pd 060511									--
//		-- converted from abstraction with the same name		--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"
#include <math.h>

static t_class *this_class;

typedef struct _f0_fold {
	t_object x_ob;
	t_float x_valLeft;
	t_float x_valMiddle;
	t_float x_valRight;
	t_float x_valOut;
	t_outlet *x_out;
} x_f0_fold;

void f0_fold_func(x_f0_fold *f0_fold);

//----------------------------------------------------------------------------------------------
void *f0_fold_new(t_symbol *s, int argc, t_atom *argv) {
	x_f0_fold *f0_fold= (x_f0_fold *)pd_new(this_class);
	floatinlet_new(&f0_fold->x_ob, &f0_fold->x_valMiddle);
	floatinlet_new(&f0_fold->x_ob, &f0_fold->x_valRight);
	f0_fold->x_valLeft= 0;
	f0_fold->x_valMiddle= 0;
	f0_fold->x_valRight= 100;
	switch(argc) {
		case 2:
			f0_fold->x_valRight= atom_getfloat(argv+1);
		case 1:
			f0_fold->x_valMiddle= atom_getfloat(argv);
	}
	f0_fold->x_out= outlet_new(&f0_fold->x_ob, gensym("float"));
	return (void *)f0_fold;
}

//----------------------------------------------------------------------------------------------
void f0_fold_float(x_f0_fold *f0_fold, t_floatarg value) {
	f0_fold->x_valLeft= value;
	f0_fold_func(f0_fold);
}
void f0_fold_bang(x_f0_fold *f0_fold) {
	outlet_float(f0_fold->x_out, f0_fold->x_valOut);
}

//----------------------------------------------------------------------------------------------
void f0_fold_func(x_f0_fold *f0_fold) {
	t_float in= f0_fold->x_valLeft;
	t_float min= f0_fold->x_valMiddle;
	t_float max= f0_fold->x_valRight;
	t_float a, b, c;
	if(min>max) {
		a= min;
		min= max;
		max= a;
	}
	if(in>=min&&in<=max||min==max) {
		b= in;
	} else {
		c= fabs(max-min)*2;
		if(in<min) {
			a= min-fmod(in-min, c);
			if(a>=min&&a<=max) {
				b= a;
			} else {
				b= max+(max-a);
			}
		} else {
			a= max-fmod(in-max, c);
			if(a>(min-c/2)&&a<=min) {
				b= min+(min-a);
			} else {
				b= a;
			}
		}
	}
	f0_fold->x_valOut= b;
	f0_fold_bang(f0_fold);
}

//----------------------------------------------------------------------------------------------
void f0_fold_setup(void) {
	this_class= class_new(gensym("f0_fold"), (t_newmethod)f0_fold_new, 0, sizeof(x_f0_fold), 0, A_GIMME, 0);
	class_addbang(this_class, (t_method)f0_fold_bang);
	class_addfloat(this_class, f0_fold_float);
	post("f0_fold v1.0.4  distributed under GNU GPL license");
}
