//		----------------------------------------------------------
//		-- fredrik olofsson 040226								--
//		-- ported to pd 060511									--
//		-- converted from abstraction with the same name		--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"

static t_class *this_class;

typedef struct _f0_frames_to_beats {
	t_object x_ob;
	t_float x_valLeft;
	t_float x_valMiddle;
	t_float x_valRight;
	t_float x_valOut;
	t_outlet *x_out;
} x_f0_frames_to_beats;

void f0_frames_to_beats_func(x_f0_frames_to_beats *f0_frames_to_beats);

//----------------------------------------------------------------------------------------------
void *f0_frames_to_beats_new(t_symbol *s, int argc, t_atom *argv) {
	x_f0_frames_to_beats *f0_frames_to_beats= (x_f0_frames_to_beats *)pd_new(this_class);
	floatinlet_new(&f0_frames_to_beats->x_ob, &f0_frames_to_beats->x_valMiddle);
	floatinlet_new(&f0_frames_to_beats->x_ob, &f0_frames_to_beats->x_valRight);
	f0_frames_to_beats->x_valLeft= 0;
	f0_frames_to_beats->x_valMiddle= 120;
	f0_frames_to_beats->x_valRight= 20;
	f0_frames_to_beats->x_valOut= 0;
	switch(argc) {
		case 2:
			f0_frames_to_beats->x_valRight= atom_getfloat(argv+1);
		case 1:
			f0_frames_to_beats->x_valMiddle= atom_getfloat(argv);
	}
	f0_frames_to_beats->x_out= outlet_new(&f0_frames_to_beats->x_ob, gensym("float"));
	return (void *)f0_frames_to_beats;
}

//----------------------------------------------------------------------------------------------
void f0_frames_to_beats_float(x_f0_frames_to_beats *f0_frames_to_beats, t_floatarg value) {
	f0_frames_to_beats->x_valLeft= value;
	f0_frames_to_beats_func(f0_frames_to_beats);
}
void f0_frames_to_beats_bang(x_f0_frames_to_beats *f0_frames_to_beats) {
	outlet_float(f0_frames_to_beats->x_out, f0_frames_to_beats->x_valOut);
}

//----------------------------------------------------------------------------------------------
void f0_frames_to_beats_func(x_f0_frames_to_beats *f0_frames_to_beats) {
	if(f0_frames_to_beats->x_valMiddle==0||f0_frames_to_beats->x_valRight==0) {
		f0_frames_to_beats->x_valOut= 0;
	} else {
		f0_frames_to_beats->x_valOut= (f0_frames_to_beats->x_valLeft/f0_frames_to_beats->x_valRight)/(60/f0_frames_to_beats->x_valMiddle);
	}
	f0_frames_to_beats_bang(f0_frames_to_beats);
}

//----------------------------------------------------------------------------------------------
void f0_frames_to_beats_setup(void) {
	this_class= class_new(gensym("f0_frames_to_beats"), (t_newmethod)f0_frames_to_beats_new, 0, sizeof(x_f0_frames_to_beats), 0, A_GIMME, 0);
	class_addbang(this_class, (t_method)f0_frames_to_beats_bang);
	class_addfloat(this_class, f0_frames_to_beats_float);
	post("f0_frames_to_beats v1.0.1  distributed under GNU GPL license");
}
