//		----------------------------------------------------------
//		-- fredrik olofsson 010505 (rev.011004					--
//		-- divide by 0 bugfix 060507 (051228)					--
//		-- ported to pd 060511									--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"
#include <math.h>

static t_class *this_class;

typedef struct _f0_gcd {
	t_object x_ob;
	t_float x_valLeft;
	t_float x_valRight;
	t_float x_valOut;
	t_outlet *x_out;
} x_f0_gcd;

void f0_gcd_func(x_f0_gcd *f0_gcd);
t_int f0_gcd_gcd(t_int a, t_int b);

//----------------------------------------------------------------------------------------------
void *f0_gcd_new(void) {
	x_f0_gcd *f0_gcd= (x_f0_gcd *)pd_new(this_class);
	floatinlet_new(&f0_gcd->x_ob, &f0_gcd->x_valRight);
	f0_gcd->x_valLeft= 0;
	f0_gcd->x_valRight= 0;
	f0_gcd->x_valOut= 0;
	f0_gcd->x_out= outlet_new(&f0_gcd->x_ob, gensym("float"));
	return (void *)f0_gcd;
}

//----------------------------------------------------------------------------------------------
void f0_gcd_float(x_f0_gcd *f0_gcd, t_floatarg value) {
	f0_gcd->x_valLeft= value;
	f0_gcd_func(f0_gcd);
}
void f0_gcd_bang(x_f0_gcd *f0_gcd) {
	outlet_float(f0_gcd->x_out, f0_gcd->x_valOut);
}
void f0_gcd_list(x_f0_gcd *f0_gcd, t_symbol *s, int argc, t_atom *argv) {
	t_int i, a, b;
	a= atom_getfloat(argv);
	for(i= 1; i<argc; i++) {
		b= atom_getfloat(argv+i);
		a= f0_gcd_gcd((t_int)a, (t_int)b);
	}
	f0_gcd->x_valOut= a;
	f0_gcd_bang(f0_gcd);
}

//----------------------------------------------------------------------------------------------
void f0_gcd_func(x_f0_gcd *f0_gcd) {
	f0_gcd->x_valOut= f0_gcd_gcd(f0_gcd->x_valLeft, f0_gcd->x_valRight);
	f0_gcd_bang(f0_gcd);
}
t_int f0_gcd_gcd(t_int a, t_int b) {	
	if(b==0) {
		return 0;
	}
	if(a%b!=0) {
		return f0_gcd_gcd(b, a % b);
	} else {
		return fabs(b);
	}
}

//----------------------------------------------------------------------------------------------
void f0_gcd_setup(void) {
	this_class= class_new(gensym("f0_gcd"), (t_newmethod)f0_gcd_new, 0, sizeof(x_f0_gcd), 0, 0);
	class_addbang(this_class, (t_method)f0_gcd_bang);
	class_addfloat(this_class, f0_gcd_float);
	class_addlist(this_class, f0_gcd_list);
	post("f0_gcd v1.1.4  distributed under GNU GPL license");
}
