//		----------------------------------------------------------
//		-- fredrik olofsson 040226								--
//		-- ported to pd 060511									--
//		-- converted from abstraction with the same name		--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"

static t_class *this_class;

typedef struct _f0_inc_dec_split {
	t_object x_ob;
	t_float x_valLeft;
	t_float x_valRight;
	t_float x_default;
	t_outlet *x_out;
	t_outlet *x_out2;
} x_f0_inc_dec_split;

void f0_inc_dec_split_func(x_f0_inc_dec_split *f0_inc_dec_split);

//----------------------------------------------------------------------------------------------
void *f0_inc_dec_split_new(t_floatarg value) {
	x_f0_inc_dec_split *f0_inc_dec_split= (x_f0_inc_dec_split *)pd_new(this_class);
	floatinlet_new(&f0_inc_dec_split->x_ob, &f0_inc_dec_split->x_valRight);
	f0_inc_dec_split->x_valLeft= 0;
	if(value!=0) {
		f0_inc_dec_split->x_valRight= value;
		f0_inc_dec_split->x_default= value;
	} else {
		f0_inc_dec_split->x_valRight= 0;
		f0_inc_dec_split->x_default= 0;
	}
	f0_inc_dec_split->x_out= outlet_new(&f0_inc_dec_split->x_ob, gensym("float"));
	f0_inc_dec_split->x_out2= outlet_new(&f0_inc_dec_split->x_ob, gensym("float"));
	return (void *)f0_inc_dec_split;
}

//----------------------------------------------------------------------------------------------
void f0_inc_dec_split_float(x_f0_inc_dec_split *f0_inc_dec_split, t_floatarg value) {
	f0_inc_dec_split->x_valLeft= value;
	f0_inc_dec_split_func(f0_inc_dec_split);
}
void f0_inc_dec_split_bang(x_f0_inc_dec_split *f0_inc_dec_split) {
	f0_inc_dec_split_func(f0_inc_dec_split);
}
void f0_inc_dec_split_reset(x_f0_inc_dec_split *f0_inc_dec_split) {
	f0_inc_dec_split->x_valRight= f0_inc_dec_split->x_default;
}

//----------------------------------------------------------------------------------------------
void f0_inc_dec_split_func(x_f0_inc_dec_split *f0_inc_dec_split) {
	if(f0_inc_dec_split->x_valLeft>=f0_inc_dec_split->x_valRight) {
		outlet_float(f0_inc_dec_split->x_out, f0_inc_dec_split->x_valLeft);
		f0_inc_dec_split->x_valRight= f0_inc_dec_split->x_valLeft;
	} else {
		outlet_float(f0_inc_dec_split->x_out2, f0_inc_dec_split->x_valLeft);
		f0_inc_dec_split->x_valRight= f0_inc_dec_split->x_valLeft;
	}
}

//----------------------------------------------------------------------------------------------
void f0_inc_dec_split_setup(void) {
	this_class= class_new(gensym("f0_inc_dec_split"), (t_newmethod)f0_inc_dec_split_new, 0, sizeof(x_f0_inc_dec_split), 0, A_DEFFLOAT, 0);
	class_addbang(this_class, (t_method)f0_inc_dec_split_bang);
	class_addfloat(this_class, f0_inc_dec_split_float);
	class_addmethod(this_class, (t_method)f0_inc_dec_split_reset, gensym("reset"), 0);
	post("f0_inc_dec_split v1.0  distributed under GNU GPL license");
}
