//		----------------------------------------------------------
//		-- fredrik olofsson 040226								--
//		-- ported to pd 060511									--
//		-- converted from abstraction with the same name		--
//		-- replaced 2nd dec-bang inlet with dec method			--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"

static t_class *this_class;

typedef struct _f0_limit_counter {
	t_object x_ob;
	t_int x_count;
	t_float x_valMiddle;
	t_float x_valRight;
	t_outlet *x_out;
	t_outlet *x_out2;
	t_outlet *x_out3;
} x_f0_limit_counter;

//----------------------------------------------------------------------------------------------
void *f0_limit_counter_new(t_symbol *s, int argc, t_atom *argv) {
	x_f0_limit_counter *f0_limit_counter= (x_f0_limit_counter *)pd_new(this_class);
	floatinlet_new(&f0_limit_counter->x_ob, &f0_limit_counter->x_valMiddle);
	floatinlet_new(&f0_limit_counter->x_ob, &f0_limit_counter->x_valRight);
	f0_limit_counter->x_count= 0;
	f0_limit_counter->x_valMiddle= -2147483647;
	f0_limit_counter->x_valRight= 2147483647;
	switch(argc) {
		case 2:
			f0_limit_counter->x_valRight= atom_getfloat(argv+1);
		case 1:
			f0_limit_counter->x_valMiddle= atom_getfloat(argv);
	}
	f0_limit_counter->x_out= outlet_new(&f0_limit_counter->x_ob, gensym("float"));
	f0_limit_counter->x_out2= outlet_new(&f0_limit_counter->x_ob, gensym("bang"));
	f0_limit_counter->x_out3= outlet_new(&f0_limit_counter->x_ob, gensym("bang"));
	return (void *)f0_limit_counter;
}

//----------------------------------------------------------------------------------------------
void f0_limit_counter_bang(x_f0_limit_counter *f0_limit_counter) {
	if(f0_limit_counter->x_count<f0_limit_counter->x_valRight) {
		f0_limit_counter->x_count= f0_limit_counter->x_count+1;
	}
	if(f0_limit_counter->x_count==f0_limit_counter->x_valRight) {
		outlet_bang(f0_limit_counter->x_out3);
	}
	outlet_float(f0_limit_counter->x_out, f0_limit_counter->x_count);
}
void f0_limit_counter_float(x_f0_limit_counter *f0_limit_counter, t_floatarg value) {
	f0_limit_counter_bang(f0_limit_counter);
}
void f0_limit_counter_inc(x_f0_limit_counter *f0_limit_counter) {
	f0_limit_counter_bang(f0_limit_counter);
}
void f0_limit_counter_dec(x_f0_limit_counter *f0_limit_counter) {
	if(f0_limit_counter->x_count>f0_limit_counter->x_valMiddle) {
		f0_limit_counter->x_count= f0_limit_counter->x_count-1;
	}
	if(f0_limit_counter->x_count==f0_limit_counter->x_valMiddle) {
		outlet_bang(f0_limit_counter->x_out2);
	}
	outlet_float(f0_limit_counter->x_out, f0_limit_counter->x_count);
}
void f0_limit_counter_set(x_f0_limit_counter *f0_limit_counter, t_floatarg value) {
	if(value<f0_limit_counter->x_valMiddle) {
		value= f0_limit_counter->x_valMiddle;
	} else if(value>f0_limit_counter->x_valRight) {
		value= f0_limit_counter->x_valRight;
	}
	f0_limit_counter->x_count= value;
}

//----------------------------------------------------------------------------------------------
void f0_limit_counter_setup(void) {
	this_class= class_new(gensym("f0_limit_counter"), (t_newmethod)f0_limit_counter_new, 0, sizeof(x_f0_limit_counter), 0, A_GIMME, 0);
	class_addfloat(this_class, f0_limit_counter_float);
	class_addbang(this_class, (t_method)f0_limit_counter_bang);
	class_addmethod(this_class, (t_method)f0_limit_counter_inc, gensym("inc"), 0);
	class_addmethod(this_class, (t_method)f0_limit_counter_dec, gensym("dec"), 0);
	class_addmethod(this_class, (t_method)f0_limit_counter_set, gensym("set"), A_DEFFLOAT, 0);
	post("f0_limit_counter v1.1  distributed under GNU GPL license");
}
