//		----------------------------------------------------------
//		-- fredrik olofsson 010614 (rev.011004)					--
//		-- ported to pd 060511									--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"
#include <math.h>

static t_class *this_class;

typedef struct _f0_noergaard {
	t_object x_ob;
	t_float x_valOut;
	t_outlet *x_out;
} x_f0_noergaard;

void f0_noergaard_func(x_f0_noergaard *f0_noergaard, t_int value);

//----------------------------------------------------------------------------------------------
void *f0_noergaard_new(void) {
	x_f0_noergaard *f0_noergaard= (x_f0_noergaard *)pd_new(this_class);
	f0_noergaard->x_valOut= 0;
	f0_noergaard->x_out= outlet_new(&f0_noergaard->x_ob, gensym("float"));
	return (void *)f0_noergaard;
}

//----------------------------------------------------------------------------------------------
void f0_noergaard_float(x_f0_noergaard *f0_noergaard, t_floatarg value) {
	if(value>=0) {
		f0_noergaard_func(f0_noergaard, (t_int)value);
	} else {
		post("f0_noergaard warning: only possitive indexes");
	}
}
void f0_noergaard_bang(x_f0_noergaard *f0_noergaard) {
	outlet_float(f0_noergaard->x_out, f0_noergaard->x_valOut);
}

//----------------------------------------------------------------------------------------------
void f0_noergaard_func(x_f0_noergaard *f0_noergaard, t_int value) {
	t_int i, n, res= 0;
	n= value;
	for(i= 0; n!=0; n= n>>1) {
		i++;
	}
	for(i--; i>=0; i--) {
		if((value>>i)&01) {
			res++;
		} else {
			if(res>=0) {
				res= 0-res;
			} else {
				res= fabs(res);
			}
		}
	}
	f0_noergaard->x_valOut= res;
	f0_noergaard_bang(f0_noergaard);
}

//----------------------------------------------------------------------------------------------
void f0_noergaard_setup(void) {
	this_class= class_new(gensym("f0_noergaard"), (t_newmethod)f0_noergaard_new, 0, sizeof(x_f0_noergaard), 0, 0);
	class_addbang(this_class, (t_method)f0_noergaard_bang);
	class_addfloat(this_class, f0_noergaard_float);
	post("f0_noergaard v1.0.4  distributed under GNU GPL license");
}
