//		----------------------------------------------------------
//		-- fredrik olofsson 040329 (rev.060511)					--
//		-- ported to pd 060511									--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#define LONG_MIN -2147483647
#define LONG_MAX 2147483647

#include "m_pd.h"

static t_class *this_class;

typedef struct _f0_range {
	t_object x_ob;
	t_float x_valLeft;
	t_float x_min;
	t_float x_max;
	t_float x_setMin;
	t_float x_setMax;
	t_int x_setFlag;
	t_outlet *x_out;
	t_outlet *x_out2;
	t_outlet *x_out3;
} x_f0_range;

void f0_range_func(x_f0_range *f0_range);

//----------------------------------------------------------------------------------------------
void *f0_range_new(t_symbol *s, int argc, t_atom *argv) {
	x_f0_range *f0_range= (x_f0_range *)pd_new(this_class);
	switch(argc) {
		case 0:
			f0_range->x_setMin= LONG_MAX;
			f0_range->x_setMax= LONG_MIN;
			break;
		case 1:
			f0_range->x_setMin= atom_getfloat(argv);
			f0_range->x_setMax= LONG_MIN;
			break;
		default:
			f0_range->x_setMin= atom_getfloat(argv);
			f0_range->x_setMax= atom_getfloat(argv+1);
	}
	f0_range->x_min= f0_range->x_setMin;
	f0_range->x_max= f0_range->x_setMax;
	f0_range->x_setFlag= argc;
	f0_range->x_out= outlet_new(&f0_range->x_ob, gensym("float"));
	f0_range->x_out2= outlet_new(&f0_range->x_ob, gensym("float"));
	f0_range->x_out3= outlet_new(&f0_range->x_ob, gensym("float"));
	return (void *)f0_range;
}

//----------------------------------------------------------------------------------------------
void f0_range_float(x_f0_range *f0_range, t_floatarg value) {
	f0_range->x_valLeft= value;
	f0_range_func(f0_range);
}
void f0_range_bang(x_f0_range *f0_range) {
	switch(f0_range->x_setFlag) {
		case 0:
			f0_range->x_min= LONG_MAX;
			f0_range->x_max= LONG_MIN;
			break;
		case 1:
			f0_range->x_min= f0_range->x_setMin;
			f0_range->x_max= LONG_MIN;
			break;
		default:
			f0_range->x_min= f0_range->x_setMin;
			f0_range->x_max= f0_range->x_setMax;
	}
}
void f0_range_set(x_f0_range *f0_range, t_floatarg value1, t_floatarg value2) {
	if(value1<value2) {
		f0_range->x_min= value1;
		f0_range->x_max= value2;
		f0_range->x_setMin= value1;
		f0_range->x_setMax= value2;
	} else {
		f0_range->x_min= value2;
		f0_range->x_max= value1;
		f0_range->x_setMin= value2;
		f0_range->x_setMax= value1;
	}
	f0_range->x_setFlag= 2;
}

//----------------------------------------------------------------------------------------------
void f0_range_func(x_f0_range *f0_range) {
	if(f0_range->x_valLeft>f0_range->x_max) {
		f0_range->x_max= f0_range->x_valLeft;
	}
	if(f0_range->x_valLeft<f0_range->x_min) {
		f0_range->x_min= f0_range->x_valLeft;
	}
	outlet_float(f0_range->x_out3, f0_range->x_max);
	outlet_float(f0_range->x_out2, (f0_range->x_max-f0_range->x_min)/2+f0_range->x_min);
	outlet_float(f0_range->x_out, f0_range->x_min);
}

//----------------------------------------------------------------------------------------------
void f0_range_setup(void) {
	this_class= class_new(gensym("f0_range"), (t_newmethod)f0_range_new, 0, sizeof(x_f0_range), 0, A_GIMME, 0);
	class_addbang(this_class, (t_method)f0_range_bang);
	class_addfloat(this_class, f0_range_float);
	class_addmethod(this_class, (t_method)f0_range_set, gensym("set"), A_DEFFLOAT, A_DEFFLOAT, 0);
	post("f0_range v1.0.2  distributed under GNU GPL license");
}
