//		----------------------------------------------------------
//		-- fredrik olofsson 040301								--
//		-- converted from abstraction with the same name		--
//		-- ported to pd 060511									--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"

static t_class *this_class;

typedef struct _f0_ratio {
	t_object x_ob;
	t_float x_valLeft;
	t_float x_valRight;
	t_float x_proportionLeft;
	t_float x_proportionRight;
	t_outlet *x_out;
	t_outlet *x_out2;
} x_f0_ratio;

void f0_ratio_func(x_f0_ratio *f0_ratio);

//----------------------------------------------------------------------------------------------
void *f0_ratio_new(t_symbol *s, int argc, t_atom *argv) {
	x_f0_ratio *f0_ratio= (x_f0_ratio *)pd_new(this_class);
	inlet_new(&f0_ratio->x_ob, &f0_ratio->x_ob.ob_pd, gensym("float"), gensym("ft1"));
	f0_ratio->x_valLeft= 0;
	f0_ratio->x_proportionLeft= 1;
	f0_ratio->x_proportionRight= 1;
	switch(argc) {
		case 2:
			f0_ratio->x_proportionRight= atom_getfloat(argv+1);
			if(f0_ratio->x_proportionRight==0) {
				f0_ratio->x_proportionRight= 1;
			}
		case 1:
			f0_ratio->x_proportionLeft= atom_getfloat(argv);
			if(f0_ratio->x_proportionLeft==0) {
				f0_ratio->x_proportionLeft= 1;
			}
	}
	f0_ratio->x_out= outlet_new(&f0_ratio->x_ob, gensym("float"));
	f0_ratio->x_out2= outlet_new(&f0_ratio->x_ob, gensym("float"));
	return (void *)f0_ratio;
}

//----------------------------------------------------------------------------------------------
void f0_ratio_bang(x_f0_ratio *f0_ratio) {
	outlet_float(f0_ratio->x_out2, f0_ratio->x_valRight);
	outlet_float(f0_ratio->x_out, f0_ratio->x_valLeft);
}
void f0_ratio_float(x_f0_ratio *f0_ratio, t_floatarg value) {
	f0_ratio->x_valLeft= value;
	f0_ratio->x_valRight= (value/f0_ratio->x_proportionLeft)*f0_ratio->x_proportionRight;
	f0_ratio_bang(f0_ratio);
}
void f0_ratio_ft1(x_f0_ratio *f0_ratio, t_floatarg value) {
	f0_ratio->x_valLeft= (value/f0_ratio->x_proportionRight)*f0_ratio->x_proportionLeft;
	f0_ratio->x_valRight= value;
	f0_ratio_bang(f0_ratio);
}
void f0_ratio_set(x_f0_ratio *f0_ratio, t_floatarg value1, t_floatarg value2) {
	if(value1==0) {
		f0_ratio->x_proportionLeft= 1;
	} else {
		f0_ratio->x_proportionLeft= value1;
	}
	if(value2==0) {
		f0_ratio->x_proportionRight= 1;
	} else {
		f0_ratio->x_proportionRight= value2;
	}
}

//----------------------------------------------------------------------------------------------
void f0_ratio_setup(void) {
	this_class= class_new(gensym("f0_ratio"), (t_newmethod)f0_ratio_new, 0, sizeof(x_f0_ratio), 0, A_GIMME, 0);
	class_addbang(this_class, (t_method)f0_ratio_bang);
	class_addfloat(this_class, f0_ratio_float);
	class_addmethod(this_class, (t_method)f0_ratio_ft1, gensym("ft1"), A_DEFFLOAT, 0);
	class_addmethod(this_class, (t_method)f0_ratio_set, gensym("set"), A_DEFFLOAT, A_DEFFLOAT, 0);
	post("f0_ratio v1.0.1  distributed under GNU GPL license");
}
