//		----------------------------------------------------------
//		-- fredrik olofsson 040226								--
//		-- ported to pd 060510									--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"
#include <math.h>

static t_class *this_class;

typedef struct _f0_round {
	t_object x_ob;
	t_float x_valLeft;
	t_float x_valRight;
	t_float x_valOut;
	t_outlet *x_out;
} x_f0_round;

void f0_round_func(x_f0_round *f0_round);

//----------------------------------------------------------------------------------------------
void *f0_round_new(t_floatarg value) {
	x_f0_round *f0_round= (x_f0_round *)pd_new(this_class);
	floatinlet_new(&f0_round->x_ob, &f0_round->x_valRight);
	f0_round->x_valLeft= 0;
	f0_round->x_valOut= 0;
	f0_round->x_out= outlet_new(&f0_round->x_ob, gensym("float"));
	if(value!=0) {
		f0_round->x_valRight= value;
	} else {
		f0_round->x_valRight= 1;
	}
	return (void *)f0_round;
}

//----------------------------------------------------------------------------------------------
void f0_round_float(x_f0_round *f0_round, t_floatarg value) {
	f0_round->x_valLeft= value;
	f0_round_func(f0_round);
}
void f0_round_bang(x_f0_round *f0_round) {
	outlet_float(f0_round->x_out, f0_round->x_valOut);
}

//----------------------------------------------------------------------------------------------
void f0_round_func(x_f0_round *f0_round) {
	if(f0_round->x_valRight==0) {
		f0_round->x_valOut= f0_round->x_valLeft;
	} else {
		f0_round->x_valOut= round(f0_round->x_valLeft/f0_round->x_valRight)*f0_round->x_valRight;
	}
	f0_round_bang(f0_round);
}

//----------------------------------------------------------------------------------------------
void f0_round_setup(void) {
	this_class= class_new(gensym("f0_round"), (t_newmethod)f0_round_new, 0, sizeof(x_f0_round), 0, A_DEFFLOAT, 0);
	class_addbang(this_class, (t_method)f0_round_bang);
	class_addfloat(this_class, f0_round_float);
	post("f0_round v1.0.5  distributed under GNU GPL license");
}
