//		----------------------------------------------------------
//		-- fredrik olofsson 020115								--
//		-- fix for output on right input 060507					--
//		-- ported to pd 060511									--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"

static t_class *this_class;

typedef struct _f0_smooth {
	t_object x_ob;
	t_float x_valLeft;
	t_float x_valRight;
	t_float x_valOut;
	t_float x_temp;
	t_outlet *x_out;
} x_f0_smooth;

void f0_smooth_func(x_f0_smooth *f0_smooth);

//----------------------------------------------------------------------------------------------
void *f0_smooth_new(t_floatarg value) {
	x_f0_smooth *f0_smooth= (x_f0_smooth *)pd_new(this_class);
	floatinlet_new(&f0_smooth->x_ob, &f0_smooth->x_valRight);
	f0_smooth->x_valLeft= 0;
	f0_smooth->x_valOut= 0;
	f0_smooth->x_temp= 0;
	if(value>0) {
		f0_smooth->x_valRight= value;
	} else {
		f0_smooth->x_valRight= 0.15;
	}
	f0_smooth->x_out= outlet_new(&f0_smooth->x_ob, gensym("float"));
	return (void *)f0_smooth;
}

//----------------------------------------------------------------------------------------------
void f0_smooth_float(x_f0_smooth *f0_smooth, t_floatarg value) {
	f0_smooth->x_valLeft= value;
	f0_smooth_func(f0_smooth);
}
void f0_smooth_set(x_f0_smooth *f0_smooth, t_floatarg value) {
	f0_smooth->x_valOut= value;
}
void f0_smooth_bang(x_f0_smooth *f0_smooth) {
	outlet_float(f0_smooth->x_out, f0_smooth->x_valOut);
}

//----------------------------------------------------------------------------------------------
void f0_smooth_func(x_f0_smooth *f0_smooth) {
	t_float St0, St1, a, Yt1;
	a= f0_smooth->x_valRight;
	St1= f0_smooth->x_valOut;
	Yt1= f0_smooth->x_temp;
	St0= a*Yt1+(1-a)*St1;	//SES - Single Exponential Smoothing, Hunter (1986)
	f0_smooth->x_valOut= St0;
	f0_smooth->x_temp= f0_smooth->x_valLeft;
	f0_smooth_bang(f0_smooth);
}

//----------------------------------------------------------------------------------------------
void f0_smooth_setup(void) {
	this_class= class_new(gensym("f0_smooth"), (t_newmethod)f0_smooth_new, 0, sizeof(x_f0_smooth), 0, A_DEFFLOAT, 0);
	class_addbang(this_class, (t_method)f0_smooth_bang);
	class_addfloat(this_class, f0_smooth_float);
	class_addmethod(this_class, (t_method)f0_smooth_set, gensym("set"), A_DEFFLOAT, 0);
	post("f0_smooth v1.1  distributed under GNU GPL license");
}
