//		----------------------------------------------------------
//		-- fredrik olofsson 020115								--
//		-- fix for output on right input 060507					--
//		-- ported to pd 060511									--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"

static t_class *this_class;

typedef struct _f0_smooth2 {
	t_object x_ob;
	t_float x_valLeft;
	t_float x_valMiddle;
	t_float x_valRight;
	t_float x_valOutLeft;
	t_float x_valOutRight;
	t_outlet *x_out;
	t_outlet *x_out2;
} x_f0_smooth2;

void f0_smooth2_func(x_f0_smooth2 *f0_smooth2);

//----------------------------------------------------------------------------------------------
void *f0_smooth2_new(t_symbol *s, int argc, t_atom *argv) {
	x_f0_smooth2 *f0_smooth2= (x_f0_smooth2 *)pd_new(this_class);
	floatinlet_new(&f0_smooth2->x_ob, &f0_smooth2->x_valMiddle);
	floatinlet_new(&f0_smooth2->x_ob, &f0_smooth2->x_valRight);
	f0_smooth2->x_valLeft= 0;
	f0_smooth2->x_valOutLeft= 0;
	f0_smooth2->x_valOutRight= 0;
	f0_smooth2->x_valMiddle= 0.15;
	f0_smooth2->x_valRight= 0.3;
	switch(argc) {
		case 2:
			f0_smooth2->x_valRight= atom_getfloat(argv+1);
		case 1:
			f0_smooth2->x_valMiddle= atom_getfloat(argv);
	}
	f0_smooth2->x_out= outlet_new(&f0_smooth2->x_ob, gensym("float"));
	f0_smooth2->x_out2= outlet_new(&f0_smooth2->x_ob, gensym("float"));
	return (void *)f0_smooth2;
}

//----------------------------------------------------------------------------------------------
void f0_smooth2_float(x_f0_smooth2 *f0_smooth2, t_floatarg value) {
	f0_smooth2->x_valLeft= value;
	f0_smooth2_func(f0_smooth2);
}
void f0_smooth2_set(x_f0_smooth2 *f0_smooth2, t_floatarg value) {
	f0_smooth2->x_valOutLeft= value;
}
void f0_smooth2_bang(x_f0_smooth2 *f0_smooth2) {
	outlet_float(f0_smooth2->x_out2, f0_smooth2->x_valOutRight);
	outlet_float(f0_smooth2->x_out, f0_smooth2->x_valOutLeft);
}

//----------------------------------------------------------------------------------------------
void f0_smooth2_func(x_f0_smooth2 *f0_smooth2) {
	t_float St0, St1, Bt0, Bt1, a, g, Yt0;
	a= f0_smooth2->x_valMiddle;
	g= f0_smooth2->x_valRight;
	St1= f0_smooth2->x_valOutLeft;
	Bt1= f0_smooth2->x_valOutRight;
	Yt0= f0_smooth2->x_valLeft;
	St1= f0_smooth2->x_valOutLeft;
	Bt1= f0_smooth2->x_valOutRight;
	St0= a*Yt0+(1-a)*(St1+Bt1);		//DES - Double Exponential Smoothing
	Bt0= g*(St0-St1)+(1-g)*Bt1;
	f0_smooth2->x_valOutLeft= St0;
	f0_smooth2->x_valOutRight= Bt0;
	f0_smooth2_bang(f0_smooth2);
}

//----------------------------------------------------------------------------------------------
void f0_smooth2_setup(void) {
	this_class= class_new(gensym("f0_smooth2"), (t_newmethod)f0_smooth2_new, 0, sizeof(x_f0_smooth2), 0, A_GIMME, 0);
	class_addbang(this_class, (t_method)f0_smooth2_bang);
	class_addfloat(this_class, f0_smooth2_float);
	class_addmethod(this_class, (t_method)f0_smooth2_set, gensym("set"), A_DEFFLOAT, 0);
	post("f0_smooth2 v1.1  distributed under GNU GPL license");
}
