//		----------------------------------------------------------
//		-- fredrik olofsson 020206								--
//		-- ported to pd 060511									--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"
#include <math.h>

static t_class *this_class;

typedef struct _f0_snap {
	t_object x_ob;
	t_float x_valLeft;
	t_float x_valRight;
	t_float x_valOut;
	t_outlet *x_out;
} x_f0_snap;

void f0_snap_func(x_f0_snap *f0_snap);

//----------------------------------------------------------------------------------------------
void *f0_snap_new(t_floatarg value) {
	x_f0_snap *f0_snap= (x_f0_snap *)pd_new(this_class);
	floatinlet_new(&f0_snap->x_ob, &f0_snap->x_valRight);
	f0_snap->x_valLeft= 0;
	f0_snap->x_valOut= 0;
	if(value>0) {
		f0_snap->x_valRight= value;
	} else {
		f0_snap->x_valRight= 50;
	}
	f0_snap->x_out= outlet_new(&f0_snap->x_ob, gensym("float"));
	return (void *)f0_snap;
}

//----------------------------------------------------------------------------------------------
void f0_snap_float(x_f0_snap *f0_snap, t_floatarg value) {
	f0_snap->x_valLeft= value;
	f0_snap_func(f0_snap);
}
void f0_snap_set(x_f0_snap *f0_snap, t_floatarg value) {
	f0_snap->x_valOut= value;
}
void f0_snap_bang(x_f0_snap *f0_snap) {
	outlet_float(f0_snap->x_out, f0_snap->x_valOut);
}

//----------------------------------------------------------------------------------------------
void f0_snap_func(x_f0_snap *f0_snap) {
	t_float stepSize, inputVal, counterVal, diff;
	stepSize= 0;
	inputVal= f0_snap->x_valLeft;
	counterVal= f0_snap->x_valOut;
	diff= fabs(inputVal-counterVal);
	if(diff!=0) {
		stepSize= f0_snap->x_valRight/diff;
	}
	if(inputVal>counterVal) {
		counterVal= counterVal+stepSize;
		if(counterVal>inputVal) {
			counterVal= inputVal;
		}
	} else if(inputVal<counterVal) {
		counterVal= counterVal-stepSize;
		if(counterVal<inputVal) {
			counterVal= inputVal;
		}
	}
	f0_snap->x_valOut= counterVal;
	f0_snap_bang(f0_snap);
}

//----------------------------------------------------------------------------------------------
void f0_snap_setup(void) {
	this_class= class_new(gensym("f0_snap"), (t_newmethod)f0_snap_new, 0, sizeof(x_f0_snap), 0, A_DEFFLOAT, 0);
	class_addbang(this_class, (t_method)f0_snap_bang);
	class_addfloat(this_class, f0_snap_float);
	class_addmethod(this_class, (t_method)f0_snap_set, gensym("set"), A_DEFFLOAT, 0);
	post("f0_snap v1.0.1  distributed under GNU GPL license");
}
