//		----------------------------------------------------------
//		-- fredrik olofsson 010522 (rev.011004)					--
//		-- ported to pd 060511									--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"
#include <math.h>

static t_class *this_class;

typedef struct _f0_tune {
	t_object x_ob;
	t_float x_valLeft;
	t_float x_valRight;
	t_float x_tonesPerOctave;
	t_float x_valOut;
	t_outlet *x_out;
} x_f0_tune;

void f0_tune_func(x_f0_tune *f0_tune);

//----------------------------------------------------------------------------------------------
void *f0_tune_new(t_floatarg value) {
	x_f0_tune *f0_tune= (x_f0_tune *)pd_new(this_class);
	floatinlet_new(&f0_tune->x_ob, &f0_tune->x_valRight);
	f0_tune->x_valLeft= 0;
	f0_tune->x_tonesPerOctave= 12;
	if(value>0) {
		f0_tune->x_valRight= value;
	} else {
		f0_tune->x_valRight= 440;
	}
	f0_tune->x_out= outlet_new(&f0_tune->x_ob, gensym("float"));
	return (void *)f0_tune;
}

//----------------------------------------------------------------------------------------------
void f0_tune_float(x_f0_tune *f0_tune, t_floatarg value) {
	f0_tune->x_valLeft= value;
	f0_tune_func(f0_tune);
}
void f0_tune_tonesPerOctave(x_f0_tune *f0_tune, t_floatarg value) {
	f0_tune->x_tonesPerOctave= value;
}
void f0_tune_bang(x_f0_tune *f0_tune) {
	outlet_float(f0_tune->x_out, f0_tune->x_valOut);
}

//----------------------------------------------------------------------------------------------
void f0_tune_func(x_f0_tune *f0_tune) {
	t_float a, b, c= 0, v;
	if(f0_tune->x_valRight!=0&&f0_tune->x_tonesPerOctave!=0) {
		v= pow(2, (1/f0_tune->x_tonesPerOctave));
		a= (log(fabs(f0_tune->x_valLeft))-log(fabs(f0_tune->x_valRight)))/log(v);
		b= round(69+a)-69;
		c= fabs(f0_tune->x_valRight)*pow(v, b);
	}
	f0_tune->x_valOut= c;
	f0_tune_bang(f0_tune);
}

//----------------------------------------------------------------------------------------------
void f0_tune_setup(void) {
	this_class= class_new(gensym("f0_tune"), (t_newmethod)f0_tune_new, 0, sizeof(x_f0_tune), 0, A_DEFFLOAT, 0);
	class_addbang(this_class, (t_method)f0_tune_bang);
	class_addfloat(this_class, f0_tune_float);
	class_addmethod(this_class, (t_method)f0_tune_tonesPerOctave, gensym("tonesPerOctave"), A_DEFFLOAT, 0);
	post("f0_tune v1.0.5  distributed under GNU GPL license");
}
