//		----------------------------------------------------------
//		-- (c) /fO 060830										--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"
#include <math.h>

static t_class *this_class;

typedef struct _f0_wrap {
	t_object x_ob;
	t_float x_valLeft;
	t_float x_valMiddle;
	t_float x_valRight;
	t_float x_valOut;
	t_outlet *x_out;
} x_f0_wrap;

float theFunction(float in, float min, float max);

//----------------------------------------------------------------------------------------------
void *f0_wrap_new(t_symbol *s, int ac, t_atom *av) {
	x_f0_wrap *f0_wrap= (x_f0_wrap *)pd_new(this_class);
	floatinlet_new(&f0_wrap->x_ob, &f0_wrap->x_valMiddle);
	floatinlet_new(&f0_wrap->x_ob, &f0_wrap->x_valRight);
	f0_wrap->x_valLeft= 0;
	f0_wrap->x_valMiddle= 0;
	f0_wrap->x_valRight= 100;
	if(ac>2) {post("warning: f0.wrap %d extra argument(s)", ac-2);}
	switch(ac) {
		case 2:
			f0_wrap->x_valRight= atom_getfloat(av+1);
		case 1:
			f0_wrap->x_valMiddle= atom_getfloat(av);
	}
	f0_wrap->x_out= outlet_new(&f0_wrap->x_ob, gensym("float"));
	return (void *)f0_wrap;
}

//----------------------------------------------------------------------------------------------
float theFunction(float in, float min, float max) {
	float a, b;
	if(min>max) {
		a= min;
		min= max;
		max= a;
	}
	if(in>=min&&in<=max||min==max) {
		a= in;
	} else {
		b= fabs(max-min);
		if(in<min) {
			a= max-fabs(fmod(in-min, b));
		} else {
			a= min+fabs(fmod(in-max, b));
		}
	}
	return a;
}

//----------------------------------------------------------------------------------------------
void f0_wrap_bang(x_f0_wrap *f0_wrap) {
	f0_wrap->x_valOut= theFunction(f0_wrap->x_valLeft, f0_wrap->x_valMiddle, f0_wrap->x_valRight);
	outlet_float(f0_wrap->x_out, f0_wrap->x_valOut);
}
void f0_wrap_float(x_f0_wrap *f0_wrap, t_floatarg value) {
	f0_wrap->x_valLeft= value;
	f0_wrap_bang(f0_wrap);
}

//----------------------------------------------------------------------------------------------
void f0_wrap_setup(void) {
	this_class= class_new(gensym("f0_wrap"), (t_newmethod)f0_wrap_new, 0, sizeof(x_f0_wrap), 0, A_GIMME, 0);
	class_addbang(this_class, (t_method)f0_wrap_bang);
	class_addfloat(this_class, f0_wrap_float);
	post("f0.wrap v1.0  distributed under GNU GPL license");
}
